#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Search Cloud
# DIZ: Enables you to display a Search Cloud in any PowerSeek templates or on any web page. A Search Cloud is a list of the latest keywords being searched for. It will display the latest keywords that was searched for.
# GRAPHIC: ic_scloud.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
#use psfp;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
# not below if's - else bypassed...
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "get_html") {&get_html;}

####################################################################################



sub get_html
{

$logging = $q->param('logging');
$font_to_use = $q->param('font_to_use');
$start_size = $q->param('start_size');
$end_size = $q->param('end_size');
$linenr = $q->param('linenr');
$maxwords = $q->param('maxwords');
$seperator = $q->param('seperator');
$template = $q->param('template');
$template_style = $q->param('template_style');


if ($maxwords eq "") { acs::problem_popup("You have to specify a number for the maximum keywords that will be displayed.");  }
if ($template eq "") { acs::problem_popup("You have to specify HTML inside the Search Cloud Main Template.");  }
if ($template_style eq "") {  acs::problem_popup("You have to specify HTML inside the Search Cloud Style Template.");  }


open (CONF, "> $data_dir/scloud1.dat");
	print CONF 		$logging . "\t" . 
						$font_to_use . "\t" . 
						$start_size . "\t" . 
						$end_size . "\t" . 
						$linenr . "\t" . 
						$maxwords . "\t" . 
						$seperator;
close (CONF);

open (TMPL, "> $data_dir/scloud2.dat");
	print TMPL $template . "--ff--oo--:-" . $template_style;
close (TMPL);


#############################################################################################################

if ($logging eq "Yes") 
	{
	
	$template_style =~ s/!!font!!/$font_to_use/g;
	$template_style =~ s/!!size!!/$start_size/g;
	$template_style =~ s/!!cloud_word!!/Test/g;
	
	$template =~ s/!!cloud_keywords!!/$template_style/g;

	$template =~ s/\n/ /g;
	$template =~ s/'/\\'/g;

	$crit1 = chr(13); $crit2 = chr(10); $template =~ s/$crit1/ /gi; $template =~ s/$crit2/ /gi; 

$crit = qq[function get_cloud()
{
document.write ('$template');
}
];


$crit2 = qq[
document.write('<script type="text/javascript" src="$web_url/sscloud.js?' + (new Date()).getTime() + '"></script>');
];


	open (CLD, "> $web_dir/sscloud.js");
	print CLD $crit;
	close (CLD);


	open (CLD, "> $web_dir/sscloudpre.js");
	print CLD $crit2;
	close (CLD);


	$hbox = acs::get_heading_box("$web_url/ic_scloud.gif", "Search Cloud Settings Updated", qq[
	You may place the following JavaScript code in any PowerSeek template or on any web page to display the Search Cloud.
	The Search Cloud will be updated each time a search is performed.<BR><BR>
	
	<form method="POST" action="$admin_url/p_scloud.cgi">
<textarea rows="10" name="jscript" cols="53" style="width:100%">
<script SRC="$web_url/sscloudpre.js"></script>
<script LANGUAGE="JavaScript" TYPE="text/javascript">
<!-- 
get_cloud();
// -->
</script>
</textarea>
	</form>
	]);


$helpb = acs::quick_help("Help",qq[
You could for example place the JavaScript in the <a href="$admin_url/admin6.cgi?fct=edit_template&template=nomatch" target="_blank">'No Match'</a> Search Result Template or the <a href="$admin_url/admin6.cgi?fct=edit_template&template=searchres" target="_blank">'Main Search Page'</a> template.
]);  


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head> 
<body>
$hbox
$helpb
</body>
</html>
];
	}
	else
	{

	$hbox = acs::get_heading_box("$web_url/ic_scloud.gif", "Search Cloud Settings Updated", qq[
	You may <a href="javascript:onClick=window.close()">close</a> this window.
	]);
	
	
	print qq[<html>
	<head>
	<title>PowerSeek</title>
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
	</head> 
	<body>
	$hbox
	</body>
	</html>
	];
	
	}

}




sub start
{

$cconf = acs::get_file_contents("$data_dir/scloud1.dat");
($logging, $font_to_use, $start_size, $end_size, $linenr, $maxwords, $seperator) = split (/\t/, $cconf);

$cconf2 = acs::get_file_contents("$data_dir/scloud2.dat");
($template, $template_style) = split (/--ff--oo--:-/, $cconf2);

$hbox = acs::get_heading_box("$web_url/ic_scloud.gif", "Search Cloud Plugin", qq[
Enables you to display a Search Cloud in any PowerSeek templates or on any web page. A Search Cloud is a list of the latest keywords being searched for.
It will display the latest keywords that was searched for.
]);


if ($logging eq "Yes")
	{
	$logging_yes = "selected";
	}
	else
	{
	$logging_no = "selected";
	}

if ($font_to_use eq "") { $font_to_use = "Verdana"; }
if ($start_size eq "") { $start_size = 1; }
if ($end_size eq "") { $end_size = 7; }
if ($linenr eq "") { $linenr = 4; }
if ($maxwords eq "") { $maxwords = 15; }
if ($seperator eq "") { $seperator = "-"; }

if ($template eq "") { $template = qq[
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#D8D8D8">
  <tr>
    <td width="100%" height="21" bgcolor="#F0F0F0"><font face="Arial" size="2"><strong>Search
    Cloud:</strong></font></td>
  </tr>
  <tr>
    <td width="100%" height="24" bgcolor="#FFFFFF" valign="top" align="center">!!cloud_keywords!!</td>
  </tr>
</table>
];
}


if ($template_style eq "") { $template_style = qq[
<font  face="!!font!!" size="!!size!!">
<a STYLE="text-decoration:none" href="!!keyword_link!!">!!cloud_word!!</a></font>
];

}






print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head> 
<body>
$hbox
<form method="POST" action="$admin_url/p_scloud.cgi">
  <input type="hidden" name="fct" value="get_html"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#D8D8D8" height="108">
    <tr>
      <td width="100%" height="21" background="$web_url/bar6.gif"
      class="normaltext" colspan="2"><strong>Search Cloud Configuration</strong></td>
    </tr>
    <tr>
      <td width="35%" height="24" bgcolor="#FFFFFF" class="normaltext" valign="top">Enable
      Keyword Logging from Searches:</td>
      <td width="65%" height="24" bgcolor="#FFFFFF" class="normaltext"><select name="logging"
      size="1">
        <option value="Yes" $logging_yes>Yes</option>
        <option value="No" $logging_no>No</option>
      </select><table border="0" cellpadding="3" cellspacing="1" width="100%">
        <tr>
          <td width="10%" align="right" class="normaltext"><strong>Yes:</strong> </td>
          <td width="90%" class="normaltext" style="border-left: 1px solid rgb(225,225,225)">Setting
          this setting to 'Yes' will enabled the Search Scripts to log keywords being searched for.
          If you want to use the 'Search Cloud' functionality then this needs to be set to 'Yes'.</td>
        </tr>
        <tr>
          <td width="10%" align="right" class="normaltext"><strong>No: </strong></td>
          <td width="90%" class="normaltext" style="border-left: 1px solid rgb(225,225,225)">Setting
          this to 'No' will disable the Search Cloud functionality and Search Scripts will not log
          keywords for the Search Cloud.</td>
        </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td width="35%" height="21" bgcolor="#FFFFFF" class="normaltext">Font to use to display
      keywords:</td>
      <td width="65%" height="21" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="font_to_use" size="35" value="$font_to_use"></td>
    </tr>
    <tr>
      <td width="35%" height="21" bgcolor="#FFFFFF" class="normaltext" valign="top">Font size
      range: (Random sizes will be chosen within this range)</td>
      <td width="65%" height="21" bgcolor="#FFFFFF" class="normaltext">Start: <input type="text"
      name="start_size" size="9" value="$start_size"> End: <input type="text" name="end_size"
      size="9" value="$end_size"><br>
      <br>
      <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
          <td width="100%"><font face="Verdana" size="1">Size 1</font></td>
        </tr>
        <tr>
          <td width="100%"><font face="Verdana" size="2">Size 2</font></td>
        </tr>
        <tr>
          <td width="100%"><font face="Verdana" size="3">Size 3</font></td>
        </tr>
        <tr>
          <td width="100%"><font face="Verdana" size="4">Size 4</font></td>
        </tr>
        <tr>
          <td width="100%"><font face="Verdana" size="5">Size 5</font></td>
        </tr>
        <tr>
          <td width="100%"><font face="Verdana" size="6">Size 6</font></td>
        </tr>
        <tr>
          <td width="100%"><font face="Verdana" size="7">Size 7</font></td>
        </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td width="35%" height="21" bgcolor="#FFFFFF" class="normaltext" valign="top">Maximum
      Number of Keywords to display in Cloud:</td>
      <td width="65%" height="21" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="maxwords" size="9" value="$maxwords"></td>
    </tr>
    <tr>
      <td width="35%" height="21" bgcolor="#FFFFFF" class="normaltext" valign="top">Keyword
      Seperator:</td>
      <td width="65%" height="21" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="seperator" size="14" value="$seperator"></td>
    </tr>
    <tr>
      <td width="35%" height="21" bgcolor="#FFFFFF" class="normaltext" valign="top">Search Cloud
      Main Template:</td>
      <td width="65%" height="21" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana"
      size="7"><textarea rows="10" name="template" cols="53" style="width:100%">$template</textarea></font><p><strong>Variables
      used in this template:</strong></p>
      <table border="0" cellpadding="3" cellspacing="1" width="100%">
        <tr>
          <td width="20%" align="right" class="normaltext"><strong>!!cloud_keywords!!</strong> </td>
          <td width="80%" class="normaltext" style="border-left: 1px solid rgb(225,225,225)">Replaced
          by the keywords of the search cloud.</td>
        </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td width="35%" height="21" bgcolor="#FFFFFF" class="normaltext" valign="top">Search Cloud
      Style Template:</td>
      <td width="65%" height="21" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana"
      size="7"><textarea rows="10" name="template_style" cols="53" style="width:100%">$template_style</textarea></font><p><strong>Variables
      used in this template:</strong></p>
      <table border="0" cellpadding="3" cellspacing="1" width="100%">
        <tr>
          <td width="20%" align="right" class="normaltext"><strong>!!font!!</strong> </td>
          <td width="80%" class="normaltext" style="border-left: 1px solid rgb(225,225,225)">Replaced
          by the font used.</td>
        </tr>
        <tr>
          <td width="20%" align="right" class="normaltext"><strong>!!size!!</strong></td>
          <td width="80%" class="normaltext" style="border-left: 1px solid rgb(225,225,225)">Replaced
          by the size of the font.</td>
        </tr>
        <tr>
          <td width="20%" align="right" class="normaltext"><strong>!!cloud_word!!</strong></td>
          <td width="80%" class="normaltext" style="border-left: 1px solid rgb(225,225,225)">Replaced
          by search keywords.</td>
        </tr>
        <tr>
          <td width="20%" align="right" class="normaltext"><strong>!!keyword_link!!</strong></td>
          <td width="80%" class="normaltext" style="border-left: 1px solid rgb(225,225,225)">Replaced by a link that will search for the keyword(s) being displayed.</td>
        </tr>        
      </table>
      </td>
    </tr>
    <tr>
      <td width="35%" bgcolor="#FFFFFF" class="normaltext" valign="top"></td>
      <td width="65%" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="Save Settings and Get HTML Code" name="B1"></td>
    </tr>
  </table>
  <div align="center"><center><table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  </center></div>
</form>

</body>
</html>
];



}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

